import { select,csv,scaleLinear,
        max,axisBottom,axisLeft,extent } from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render=(data)=>{
const circleRadius=10;
const margin={top:20, right:20, bottom:20, left:20}
const innerWidth=width-margin.left-margin.right
const innerHeigth=height-margin.top-margin.bottom

const xValue= d=>d.horsepower  
const xScale=scaleLinear()
.domain(extent(data,xValue))
.range([0,innerWidth])
.nice()

const yValue=d=>d.weight
const yScale=scaleLinear()
.domain(extent(data,yValue))
.range([0,innerHeight])
.nice()


const g=svg.append('g')
.attr('transform',`translate(${margin.top}, ${margin.left})`);

const xAxis=axisBottom(xScale)  
.tickSize(-innerHeight);

const yAxis=axisLeft(yScale)
.tickSize(-innerWidth);

  
g.append('g')
.call(yAxis)
.selectAll('.domain')
.remove() 
  
const xAxisG=g.append('g')
.call(xAxis)
.attr('transform',`translate(0, ${innerHeight})`)
xAxisG.append('text')
.attr('class','axis-label')
.attr('y',65)
.attr('x',innerWidth/2)
.attr('fill','black')
 .attr('text','Scatter Plot') 
  
g.selectAll('circle')
.data(data)
.enter().append('circle')
.attr('cx',d=>xScale(xValue(d)))
.attr('cy',d=>yScale(yValue(d)))
.attr('r',circleRadius) };

csv('https://vizhub.com/Sergiop79/datasets/auto-mpg.csv')
.then(data=>{
data.forEach((d)=>{
d.mpg=+d.mpg
d.cylinder=+d.cylinder
d.displacement=+d.displacement
d.horsepower=+d.horsepower  
d.weight=+d.weight
d.accleration=+d.acceleration
d.year=+d.year
})
render(data)  
});